#!/usr/bin/env python
# -*- coding: UTF-8 -*-

"""
Per usarelo:
1) Scaricare python 2.5
2) Scaricare l'estensione pythonWin32com da
  http://starship.python.net/crew/mhammond
3) Scaricare un driver PDF che possa funzionare in background come
    PDFCreator
    (cercarne uno migliore per la produzione, per)
  PDFCreator consente di definire anche una cartella dove deve salvare i pdf
  Aprire le sue opzioni ed il tab <AutoSave>
  Definirla in C:/temp
  Definire come nome del filename:
   <Title><DateTime>
4) Configurare la stampante pdf come default printer (per semplifciare le cose)

5)Provare con:
.\iepilot.py http://www.repubblica.it 

Reference
http://mail.python.org/pipermail/python-win32/2003-March/000822.html
http://mail.python.org/pipermail/python-list/2003-October/232485.html
http://msdn.microsoft.com/en-us/library/aa752058(VS.85).aspx
 
Per stampare non c' un modo diretto, si deve chiamare ExecWB() repeatedly with the OLECMDID_PRINT
command and the OLECMDOPT_DONTPROMPTUSER option
See http://support.microsoft.com/kb/188271/en-us


See also similar projects
http://pamie.sourceforge.net/



.\iepilot.py "C:\giorgi\Projects\unicredit_holding\doc\current_docs\UCH_html\editorial_12.htm"
"""

APPSERVER_DISPATCHER_PORT=2323
APPSERVER_GLOBAL_SHUTDOWN_NOW=False

from win32com.client import Dispatch,DispatchWithEvents
import sys,time,datetime,os,distutils.file_util
import xmlrpclib


"""
"""
def getDestDirectory():
    PDFCreator = Dispatch('PDFCreator.clsPDFCreator')    
    PDFCreator.cStart("/ClearCache", 1)
    options = PDFCreator.cOptions
    return options.AutosaveDirectory

# Must end with /
#TEMP_DIR="c:/temp/"
TEMP_DIR=getDestDirectory()+"/"
print "======== CONFIG "
print "DESTINATION DIRECTORY OF PDF:",TEMP_DIR


#from pythoncom import PumpWaitingMessages, PumpMessages
#
## Optain the PDFCreator
#class clsPDFCreatorEvents(object):
#	def OneReady(self):
#		print "Ready."
#		global ReadyState
#		ReadyState = 1
#	def OneError(self):
#		ReadyState = 0
#		global PDFCreator
#		print "An error is occured!\r\n Error [" + \
#		str(PDFCreator.cErrorDetail("Number")) + "]: " + \
#		PDFCreator.cErrorDetail("Description")
#		errNum = PDFCreator.cErrorDetail("Number")
#		PDFCreator = None
#		os._exit(errNum)
#PDFCreator = Dispatch('PDFCreator.clsPDFCreator')
##PDFCreatorEvents = DispatchWithEvents(PDFCreator, clsPDFCreatorEvents)
##ProgramIsRunning = PDFCreator.cProgramIsRunning
##PDFCreator.cStart("/NoProcessingAtStartup", 1)
#oldOptions = PDFCreator.cOptions
#
#def setOutputFile(fname):
#    global PDFCreator    
#    options = PDFCreator.cOptions
#    print "Current AutoSave directory:",options.AutosaveDirectory
#    print "Current autosave filename",options.AutosaveFilename
#    #options.UseAutosave = 1
#    #options.UseAutosaveDirectory = 1
#    #options.AutosaveFormat = 0      # 0 = PDF
#    #options.AutosaveDirectory = dirname
#    # Put here only the 
#    options.AutosaveFilename=fname
#    PDFCreator.cSaveOptions(options)
#    print "Succesful set output filename to",fname
#

#setOutputFile("temp.pdf")

#sys.exit(0)




def existSimilarFile(fileName):
    global TEMP_DIR
    for root, dirs, files in os.walk(TEMP_DIR):
        for candidate in files:
            if candidate.startswith(fileName):
                return candidate
    return None

def waitIE(ieobject,sleepTime=1):
    # Ogni tanto IE.Busy genera un
    # AttributeError: InternetExplorer.Application.Busy
    isbusy=True
    print "Waiting IE..."
    while isbusy:        
        try:
            isbusy=ieobject.Busy
            if sleepTime>0:
                time.sleep(sleepTime)            
        except AttributeError:
            print "WARNING; COM Transient Error"
            pass
    return None

def web2pdf(webURL):    
    global TEMP_DIR
    startTime=datetime.datetime.now()    
    IE=Dispatch("InternetExplorer.Application")
    print "URL TO PROCESS:",webURL
    waitIE(IE,sleepTime=0)
    #IE.Visible=1
    IE.Navigate(webURL)
    # Questo deve essere maggiore di zero.
    # Un valore prudenziale  1 secondo, ma per migliorare le performance ho posto:
    waitIE(IE,sleepTime=0.18)

    #print "Document title after busy:",IE.Document.title
    # fileTitle=IE.Document.title.replace(" ","_")+".pdf"
    print "*** Location to transform to find filename:",IE.LocationURL
    """ The url is used to save the pdf
    we must use a guess algorithm, using also the date
    http://www.corriere.it => http___www.corriere.it_20081022165802.pdf
    http___www.unicreditgroup.eu_DOC_jsp_navigation_index.jsp_parLo20081022171632.pdf
    
    The file name is limited to 64 chars
     The last part is something like
     20081022172015
     YYYYMMDDHHMMSS
    
     Now we should zap other bad files in the temp dir and then Proceed
    
     IE.Document  il modello dom
    import win32com.client.constants
     Le costanti non funzionano, per cui usando Google sono state derivate
     Vedi http://msdn.microsoft.com/en-us/library/ms691264(VS.85).aspx
     e http://msdn.microsoft.com/en-us/library/ms683930(VS.85).aspx
    OLECMDID_PRINT = 6
    """
    currentIEURL=IE.LocationURL    
    print "IE URL:",currentIEURL            
    if currentIEURL.startswith(webURL[0:10])==False:
        print ":::::: WARNING ::::: Automation not working as expeted: final url is not the expected one"
        print        
    pdfFileName=IE.LocationURL.replace("http://","http___")[0:63]
    pdfFileName=pdfFileName.replace("/","_")
    pdfFileName=pdfFileName.replace("?","_")    
    pdfFileName=pdfFileName+datetime.datetime.now().strftime("%Y%m%d%H")
    OLECMDID_PRINT = 6
    OLECMDEXECOPT_DODEFAULT        = 0
    OLECMDEXECOPT_DONTPROMPTUSER    = 2
    print "Sending print command..."
    IE.ExecWB(OLECMDID_PRINT,OLECMDEXECOPT_DONTPROMPTUSER)
    print "...Done"    
    print "Guessed FileName will start with ",TEMP_DIR+pdfFileName
    #Check if it exist:
    fileFromPDFCreator=None
    fileToSendBack=None
    countDown=40
    #print "Waiting a bit PDFCreator Async Chain..."
    #time.sleep(1)
    allDone=False
    while allDone==False:
        fileFromPDFCreator=existSimilarFile(pdfFileName)
        countDown=countDown-1
        if fileFromPDFCreator:
            #print "File To Send Back:",fileFromPDFCreator
            # Send the file
            # Rename/delete the file to avoid confusion
            fileToSendBack="Processed_"+fileFromPDFCreator[7:]            
            try:
                distutils.file_util.move_file(TEMP_DIR+fileFromPDFCreator, TEMP_DIR+fileToSendBack,verbose=1)
                print "*** Move succesful. Destiantion:", fileToSendBack
                allDone=True
            except Exception,e:
                if str(e).find("The process cannot access the file because it is being used by another process")>0:                
                    #print "Cannot move file:PDFCreator is slowing generating the pdf..."                    
                    pass
                else:                    
                    print "Fatal error:\n\t",str(e)                    
                    allDone=True
                    fileToSendBack=None
                continue
            break
        else:
            # Abbassare troppo questo valore (es 0.30 per intenderci)
            # genera errori COM fatali
            #print "WARNING: FILE NOT YET GENERATED, Sleeping 0.3 sec ", str(countDown)
            time.sleep(0.39)
        if countDown <=0:
            print "***** Operation Timed out. ******"
            print webURL, "Print PDF FAILED"
            fileToSendBack=None
            allDone=True
            break        
    # Close only succesful loads
    if fileToSendBack:
        IE.Quit()
        usedTime=datetime.datetime.now() -startTime
        print webURL, " Processed into ", usedTime.seconds
    return fileToSendBack



#
#def forkWeb2pdf(url):
#    from threading import Thread
#    def myfun():
#        web2pdf(url)
#    t=Thread(target=myfun, name=url)
#    t.setDaemon(False)
#    t.start()
#    time.sleep(2)
#    


def batchProcess(fileName):
    total=0
    processed=0
    #  url-list.txt
    f=file(fileName)
    processUrls(f.readlines())
    f.close()
    
def processUrls(urlList):
    total=0
    processed=0
    for url in urlList:
        if web2pdf(url):
            processed=processed+1        
        total=total+1    
    if processed < total:
        print "Failed:", (total-processed), " on ", total
    else:
        print "100% Success!"


def unrollfiles():
    global FILE_LIST
    return FILE_LIST.pop(0)


def shutdownServer(userid,password):
    global APPSERVER_GLOBAL_SHUTDOWN_NOW
    print "[APPSERVER] ", "Shutdown request... proceeding to shutdown now..."
    APPSERVER_GLOBAL_SHUTDOWN_NOW=True
    return "Shutdown accepted"



def runAsDispatchServer(fileNameListDoDispatch):
    global APPSERVER_DISPATCHER_PORT
    global APPSERVER_GLOBAL_SHUTDOWN_NOW
    global FILE_LIST
    f=file(fileNameListDoDispatch)
    FILE_LIST=f.readlines()
    f.close()
    print "LOADED URLS:", str(len(FILE_LIST))
    from SimpleXMLRPCServer import SimpleXMLRPCServer
    server = SimpleXMLRPCServer(("localhost", APPSERVER_DISPATCHER_PORT))
    server.register_function(unrollfiles,"nextUrl")
    # optional:
    server.register_function(shutdownServer,"shutdown")    
    print "[APPSERVER] ", "Shutdown hook registered. Launching:"+str(server)
    startTime=datetime.datetime.now()
    requestSent=0
    while APPSERVER_GLOBAL_SHUTDOWN_NOW==False:
        server.handle_request()
        requestSent=requestSent+1
        if len(FILE_LIST)==0:
            sys.exit(0)
        if len(FILE_LIST) % 11 == 1:            
            usedTime=datetime.datetime.now() -startTime
            reqSec=float(requestSent)/float(usedTime.seconds)
            print "Remaining ", str(len(FILE_LIST))," Req/Sec ",reqSec, " running seconds:", usedTime.seconds    
    # See SocketServer.TCPServer
    server.server_close()

def runAsWorker():
    import random
    random.seed()
    randomSleep=random.randint(1,2)-0.5
    del random
    print "Worker Sleeping a bit:",randomSleep    
    time.sleep(randomSleep)
    global APPSERVER_DISPATCHER_PORT
    s = xmlrpclib.Server('http://localhost:'+str(APPSERVER_DISPATCHER_PORT))
    try:
        while True:
            myurl=s.nextUrl()
            print "URL TO PROCESS:",myurl
            web2pdf(myurl)
    except Exception,e:
        print str(e)
        print "Worker shutdown"
        sys.exit(0)


####MAIN
if len(sys.argv)<=1:
    batchProcess("url-list.txt") 
else:
    option=sys.argv[1]
    if option=="-dispatcher":
        runAsDispatchServer(sys.argv[2])
    elif option=="-worker":
        runAsWorker()
    else:
        processUrls(sys.argv[1:])
